        real time(100000)
        real v1(100000)
        real v2(100000)
        real v3(100000)
        real e1(100000)
        real e2(100000)
        real e3(100000)
        real n1(100000)
        real n2(100000)
        real n3(100000)
        
        character*100 char1

        open(unit=1,file='energy_time_averages',status='old')
        j = 1
1       read(1,*,END=2)time(j),e1(j),e2(j),e3(j)
        j = j + 1
        goto 1
2       j_fix = j-1
        close(1)
        print*,j_fix

        open(unit=1,file='vy_time_averages',STATUS='old')
        j = 1
3       read(1,*,END=4)time(j),v1(j),v2(j),v3(j)
        j = j + 1
        goto 3
4       j_fix = j-1
        close(1)
        print*,j_fix

        open(unit=1,file='valley_occupation',STATUS='old')
        j = 1
5       read(1,*,END=6)time(j),n1(j),n2(j),n3(j)
        j = j + 1
        goto 5
6       j_fix = j-1
        close(1)
        print*,j_fix
        
        dt = time(j_fix)-time(j_fix-1)
        print*,'begining of the time averaging procedure'
        read*,time_start
        jj = time_start/dt

        sum_v1 = 0
        sum_v2 = 0
        sum_v3 = 0
        sum_e1 = 0
        sum_e2 = 0
        sum_e3 = 0
        sum_n1 = 0
        sum_n2 = 0
        sum_n3 = 0
       
        do j = jj,j_fix
           sum_v1 = sum_v1 + v1(j)
           sum_v2 = sum_v2 + v2(j)
           sum_v3 = sum_v3 + v3(j)
           sum_e1 = sum_e1 + e1(j)
           sum_e2 = sum_e2 + e2(j)
           sum_e3 = sum_e3 + e3(j)
           sum_n1 = sum_n1 + n1(j)
           sum_n2 = sum_n2 + n2(j)
           sum_n3 = sum_n3 + n3(j)
        enddo

        sum_v1 = sum_v1/float(j_fix-jj+1)
        sum_v2 = sum_v2/float(j_fix-jj+1)
        sum_v3 = sum_v3/float(j_fix-jj+1)

        sum_e1 = sum_e1/float(j_fix-jj+1)
        sum_e2 = sum_e2/float(j_fix-jj+1)
        sum_e3 = sum_e3/float(j_fix-jj+1)

        sum_n1 = sum_n1/float(j_fix-jj+1)
        sum_n2 = sum_n2/float(j_fix-jj+1)
        sum_n3 = sum_n3/float(j_fix-jj+1)
        sum_ntot = sum_n1 + sum_n2 + sum_n3
        sum_n1 = sum_n1/sum_ntot
        sum_n2 = sum_n2/sum_ntot
        sum_n3 = sum_n3/sum_ntot              

        av_velocity = sum_v1*sum_n1 + sum_v2*sum_n2
     1              + sum_v3*sum_n3

        av_energy = sum_e1*sum_n1 + sum_e2*sum_n2
     1            + sum_e3*sum_n3

        print*,'Average velocity = ',av_velocity
        print*,'Average energy = ',av_energy

        end   
                                            
         